Subject: Re: [PATCH net-next v2 00/12] cdc_ncm: add buffer tuning and stats using ethtool

From: Lars Melin <[email-masked]>
Date: Mon, 19 May 2014 00:10:29 +0700

On 2014-05-18 21:50, Bjørn Mork wrote:
> I could be wrong, but my impression is that the userspace API
> preferences for network devices are
>
>   1. ethtool
>   2. sysfs
>   3. module param
>   ..
>   99. ioctl
>
> This is the primary reason why I was looking for someplace to put this
> within the existing ethtool API.  Using sysfs would have worked fine
> too, I guess.  But is there any real advantage, making it worth a
> switch?  I am all open to change to sysfs instead before v3.16 is
> released, *if* there are good reasons to do it. And no objections.  But
> I do want more of a reason than the fact that it can be done.  Maybe I
> got the preferred order wrong?
>
> I ruled out module parameters early because I believe there are real use
> cases requiring different settings per device.  The limited host system
> resources will of course affect all devices on a single host the same
> way.  But not all devices can cope with the reduced buffers. So there
> should be some way to tune two devices connected to the same host
> differently.
>
> I am not going to say anything about ioctls :-)
>
>
> Bjørn
> --

Your target audience is embedded systems with limited cpu power and 
buffer memory, right?
If so, then you can't expect them to have ethtool included and their 
developers are not likely to be happy over having to "waste" another 
100KB in order to tune a 20KB driver.
My vote goes for sysfs.

/Lars